/**
 *   Java application: Tic-Tac-Toe game for two players
 *   Conversion of TTTApplet (main differences are marked
 *   by // !!!=== )
 *   
 *   Georgy Gimel'farb 12.08.1998
 *   (last modified: 15.09.98)
 */

import java.awt.*;       // !!!=== importing java.awt and java.awt.event
import java.awt.event.*; // !!!=== packages instead of java.applet

public class TTTApplication extends Frame {   // !!!=== Frame instead of Applet
  Label lab = new Label("Tic-Tac-Toe", Label.CENTER ); 
  Panel pan = new Panel();
  Button [] sq = new Button [ 9 ];
  Panel south = new Panel();            // !!!=== new Panel to place 2 new buttons
  Button quit = new Button("Exit");     // !!!=== to quit and to reload a game (an
  Button reload = new Button("Reload"); // !!!=== applet does this itself)
  int ply = 2; 

  // placing the 3 x 3 array of the game buttons onto the central panel
  // and handling the buttons' events
  public void start() {
    for ( int p = 0; p < 9; p ++ ) { 
      sq[ p ] = new Button( "." );                       // initially unmarked button
      sq[ p ].setActionCommand( Integer.toString( p ) ); // setting unique action command to
                                                         // each the button ( (String) "p" ) 
      sq[ p ].addActionListener( new ActionListener() {  // handling a user move (that is, when
        public void actionPerformed( ActionEvent e ) {   // the button is clicked on )
	  int b = new Integer( e.getActionCommand() ).intValue(); // int value of the action command
          move( b );                                     // handling the move for this button
	}
      } );
      pan.add( sq[ p ] );                                // add the button to the panel pan
    }      
  }

  public void init() {
    sandmark.watermark.ct.trace.Annotator.sm$mark();
    setBackground( Color.green );                 // colour of the game board
    setForeground( Color.yellow );                // colour of the labels / marks
    setFont( new Font("SansSerif", Font.BOLD, 60 ) ); // font type
    setSize( 360, 360 );                          // size of the game window 
    setLayout( new BorderLayout() );              // basic layout of the window
    addWindowListener( new WindowAdapter() {       // !!!=== this listener has to close
      public void windowClosing( WindowEvent e ){  // !!!=== or exit the instantiated
        dispose();                                 // !!!=== game window (an applet
        System.exit( 0 );                          // !!!=== does this itself but an
      }                                            // !!!=== application can't be closed
    } );                                           // !!!=== without this listener     
    add ( "North",  lab );
    add ( "Center", pan );
    pan.setLayout( new GridLayout( 3, 3 ) );
    sandmark.watermark.ct.trace.Annotator.sm$mark();
    south.setLayout( new FlowLayout() );       // !!!=== to set a panel layout to 
                                               // !!!==  place the quit/reload buttons

    quit.addActionListener( new ActionListener() {    // !!!=== to handle the actions after
      public void actionPerformed( ActionEvent e ) {  // !!!=== clicking on the quit button:
	dispose();                                    // !!!===  disposing the window and
	System.exit( 0 );                             // !!!===  exiting the program
      }                                               // !!!===
    } );                                              // !!!===
    reload.addActionListener( new ActionListener() {  // !!!=== to handle the actions after
      public void actionPerformed( ActionEvent e ) {  // !!!=== clicking on the reload button:
	clear();                                      // !!!===  restoring unmarked states of       
      }                                               // !!!===  all the nine game buttons
    } );                                              // !!!=== 
    add( "South", south );                            // !!!=== add the panel to the window         
    south.add( quit );                                // !!!=== and add the two button to
    south.add( reload );                              // !!!=== this panel
  }

  public static void main( String[] args ) {          // !!!=== the main method instantiates
    TTTApplication ttt = new TTTApplication();        // !!!=== this class, applies init() and
    ttt.init();                                       // !!!=== start() methods, shows the
    ttt.start();                                      // !!!=== window, and then exits (all
    ttt.pack();                                       // !!!=== subsequent actions for the
    ttt.show();                                       // !!!=== instance ttt are carried out
  }                                                   // !!!=== by listening to and catching
                                                      // !!!=== particular GUI events)

  public void clear() {                               // !!!=== new method to restart the
    setForeground( Color.yellow );                    // !!!=== game: sets the yellow foreground
    for ( int p = 0; p < 9; p ++ )                    // !!!=== colour, unmarks the game buttons,
      sq[ p ].setLabel( "." );                        // !!!=== and restore the initial text
    sandmark.watermark.ct.trace.Annotator.sm$mark();
    lab.setText("Tic-Tac-Toe");                       // !!!=== for the game label
  }                                                   // !!!===

// the methods below are the same either
// for the TTT application or the TTT Applet
  
public void move( int b ) {                         // @param b -- number of a button
    if ( !hit() && free() ) {                       // If there are unmarked (free) buttons
      ply = ( ply == 2 )? 1 : 2;                    // and the game is not over, toggle the
      sandmark.watermark.ct.trace.Annotator.sm$mark(ply);
      mark( b );                                    // players and mark the button "X" or "O";
      if ( hit() ) { setForeground( Color.blue );   // if there is a hit (3 "X" or "O" in a line,
      lab.setText ("Player " + ply + " won!");      // congratulate the winner;
      }
    }
    else {                                          // otherwise ask to reload the game
      if ( free() ) setForeground( Color.magenta );
      else          setForeground( Color.red );
      lab.setText ("Reload game!");
    }
  }

  public boolean free() {                           // check if there are unmarked buttons
     boolean f = false;
     for( int b = 0; b < 9; b++ ) 
        if  ( sq[ b ].getLabel() == "." ) f = true;
     return f;
  }

  public boolean hit() {                           // check if there are "3-in-line" marks
    boolean hit = singleHit(0,4,8) | singleHit(2,4,6);
    for(int p = 0; p<3; p++) hit |= singleHit(p,p+3,p+6);
    for(int p = 0; p<9; p+=3) hit |= singleHit(p,p+1,p+2);
    return hit; 
  }  

  public void mark( int b ) {                      // mark the button b
    if ( sq[ b ].getLabel() == "." ) {
      if ( ply == 1 ) 
        sq[ b ].setLabel( "X" );
      else 
        sq[ b ].setLabel( "O" ); 
      sandmark.watermark.ct.trace.Annotator.sm$mark(b);
    }
  } 

  private boolean singleHit( int b1, int b2, int b3 ) {  // check a "3-are-similar" event
    return ( ( sq[ b1 ].getLabel() != "." ) &&
             ( sq[ b1 ].getLabel() == sq[ b2 ].getLabel() ) &&
             ( sq[ b1 ].getLabel() == sq[ b3 ].getLabel() ) );
  } 
}

